import java.awt.*;
import java.awt.event.*;

public class Input_source extends Frame
{
    int[]   text_has_been_entered = new int[1]; // The condition variable

    TextField input = new TextField();

    public Input_source()
    {
        input.addActionListener
        (   new ActionListener()
            {   public void actionPerformed( ActionEvent e )
                {                                           
                    synchronized( text_has_been_entered )
                    {   text_has_been_entered.notify();  // set the condition true
                    }                                           
                }
            }
        );

        add(input);
        pack();
        show();
    }


	/** A blocking function that works like readLine(), but gets its
	 *	text from the current window's text area. The function doesn't
	 *  return until sombody types a line of text, whereupon it returns
	 *	the line. Returns null if the user types an empty line.
	*/

    synchronized String read_line() throws InterruptedException
    {   
        synchronized( text_has_been_entered )
        {   text_has_been_entered.wait(); // wait for the condition to become true
        }                                                               
        
        String entered = input.getText();
        input.setText("");
        return (entered.length() == 0) ? null : entered;

    }


    static public void main( String[] args ) throws Exception
    {   Input_source source = new Input_source();
        String input;

        while( (input = source.read_line()) != null )
            System.out.println("Got: " + input );

        System.exit(0);         // kill the AWT Thread on exit
    }
}
