import java.util.*;
import com.holub.tools.Command;
import com.holub.tools.Multicaster;

public class Multicast_publisher
{
	Command subscription_list; // = null

	public synchronized void subscribe( Command subscriber )
	{	subscription_list =
						Multicaster.add(subscription_list,subscriber);
	}

	public synchronized void cancel_subscription( Command subscriber )
	{	subscription_list =
					Multicaster.remove(subscription_list, subscriber);
	}

	public void publish()
	{	
		new Thread()
		{	public void run()
			{	if( subscription_list != null )	
					subscription_list.execute( "Hello world" );
			}
		}.start();
	}

	public void publish_sequentially()
	{
		new Thread()
		{	public void run()
			{	synchronized( subscription_list )
				{	if( subscription_list != null )	
						subscription_list.execute( "Hello world" );
				}
			}
		}.start();
	}
	//================================================================
	public static class Test
	{	
		static private Multicast_publisher publisher  =
											new Multicast_publisher();

		static private Command subscriber =
								new Command()
								{	public void execute(Object p)
									{	System.out.println((String)p);
									}
								};

		static public void main( String[] args )
		{	publisher.subscribe( subscriber );
			publisher.publish();	// Publish "Hello world" events
		}
	}
}
